/* ,        
	AT90S8535
   D      . 
 0   ,  1  ,   2  . 
   ""        
(    3  ). 
   1        ,   1..2   , 
    2   .
      ADCL:ADCH,   WinAVR   ADCW. 
   10 ,         5 . 
 ,      ADCW   ,  1 * (2 ^10 - 1) / 5 = 1023 / 5.
        ( 2046 / 5) 
  (1023 / 5 .. .2046 / 5) .*/

#include <avr/io.h>
#include <avr/interrupt.h>  //    sei()
#include <avr/signal.h>     //    INTERRUPT

ISR (ADC_vect) //    
{
	unsigned int ADCdata;  //  . 
	ADCdata = ADCW;        	// 
	if (ADCdata > (2046 / 5)) PORTD = 3;  		// U > 2 ,  PORTD = 011 ("") 
	else if (ADCdata < (1023 / 5)) PORTD = 6; // U < 1 ,  PORTD - 110 ("")
	else PORTD = 5;  							// U = 1..2 , PORTD = 101 ("") 
	ADCSR = ADCSR | 0x40; //  ADSC   ADCSR,     
}
 
int main (void) 
{
	DDRD = 7;		//    D -   
	ADMUX = 3; 		//      ; 
	ADCSR = OxCE; 	/* 0b11001110 -      64, 
						       */  
	sei();			//  
	while(1) ; 	//      
}

 

